/*
 * Copyright 2002 Sun Microsystems, Inc. All rights reserved.
 * SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/*
 * @(#)AccessBridgeDebug.cpp	1.8 02/08/23
 */

/* 
 * A class to manage AccessBridge debugging
 */

#include "AccessBridgeDebug.h"
#include <stdarg.h>
#include <stdio.h>
#include <windows.h>

// #define SEND_TO_OUTPUT_DEBUG_STRING
// #define SEND_TO_CONSOLE

/**
 * Send the debugging info to the appropriate place
 *
 */
void PrintDebugString(char *msg, ...) {
#ifdef DEBUGGING_ON
    char buf[1024];
    va_list argprt;

    va_start(argprt, msg);     // set up argptr
    vsprintf(buf, msg, argprt);
#ifdef SEND_TO_OUTPUT_DEBUG_STRING
    OutputDebugString(buf);
#endif
#ifdef SEND_TO_CONSOLE
    printf(buf);
    printf("\r\n");
#endif
#endif
}

/**
 * Wide version of the method to
 * send the debugging info to the appropriate place
 *
 */
void wPrintDebugString(wchar_t *msg, ...) {
#ifdef DEBUGGING_ON
    char buf[1024];
    char charmsg[256];
    va_list argprt;

    va_start(argprt, msg);          // set up argptr
    wsprintf(charmsg, "%ls", msg);  // convert format string to multi-byte
    wvsprintf(buf, charmsg, argprt);
#ifdef SEND_TO_OUTPUT_DEBUG_STRING
    OutputDebugString(buf);
#endif
#ifdef SEND_TO_CONSOLE
    printf(buf);
    printf("\r\n");
#endif
#endif
}
